def factorial(number : Int) = {
  @scala.annotation.tailrec
  def factorialImpl(fact : BigInt, number : Int) : BigInt = {
    if (number == 1)
      fact
    else
      factorialImpl(number * fact, number - 1)
  }
  
  factorialImpl(1, number)
}

println(factorial(5))
println(factorial(5000))